
#include "BOARD.h"
#include <stdio.h>


char sourcestring[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
char deststring1[] = "!!!!!!!!!!!!!!!!!!!!!!!!!!";
char deststring2[] = "!!!!!!!!!!!!!!!!!!!!!!!!!!";
char deststring3[] = "!!!!!!!!!!!!!!!!!!!!!!!!!!";

void sloppy_copy(register char * to, const register char * from, int count)
{
    register n = count;
    do { /* count > 0 assumed */
        *to++ = *from++;
    } while (--n > 0);
}

//this version saves a bit of time, but only works if count
//is evenly divisible by 8!

void quick_copy(register char * to, const register char * from, int count)
{
    register n = count / 8;
    do {
        *to++ = *from++;
        *to++ = *from++;
        *to++ = *from++;
        *to++ = *from++;
        *to++ = *from++;
        *to++ = *from++;
        *to++ = *from++;
        *to++ = *from++;
    } while (--n > 0);
}

//so

void duffs_device(register char * to, 
        const register char * from, int count)
{
    register n = (count + 7) / 8;
    switch (count % 8) {
    case 0: do {
            *to++ = *from++;
        case 7: *to++ = *from++;
        case 6: *to++ = *from++;
        case 5: *to++ = *from++;
        case 4: *to++ = *from++;
        case 3: *to++ = *from++;
        case 2: *to++ = *from++;
        case 1: *to++ = *from++;
        } while (--n > 0);
    }
}

int main(void)
{

    sloppy_copy(deststring1, sourcestring, 26);
    quick_copy(deststring2, sourcestring, 26);
    duffs_device(deststring3, sourcestring, 26);

    while (1);
}
